Index: soft/giet_vm/xml/xml_parser.c
===================================================================
--- soft/giet_vm/xml/xml_parser.c	(revision 226)
+++ soft/giet_vm/xml/xml_parser.c	(revision 228)
@@ -1270,54 +1201,54 @@
             return;
         }
-        else 
-        {
-            printf("[XML ERROR] Unknown tag %s",tag);
-            exit(1);
-        }
-        status = xmlTextReaderRead ( reader );
+        else {
+            printf("[XML ERROR] Unknown tag %s", tag);
+            exit(1);
+        }
+        status = xmlTextReaderRead(reader);
     }
 } // end coprocNode()
 
+
 ///////////////////////////////////////
-void irqNode( xmlTextReaderPtr reader )
-///////////////////////////////////////
-{
-    unsigned int 	ok;
-    unsigned int 	value;
-    char*    		str;
-
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-    if ( irq_index >= MAX_IRQS )
-    {
+void irqNode(xmlTextReaderPtr reader) {
+    unsigned int ok;
+    unsigned int value;
+    char * str;
+
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+    if (irq_index >= MAX_IRQS) {
         printf("[XML ERROR] The number of irqs is larger than %d\n", MAX_IRQS);
     }
 
 #if XML_PARSER_DEBUG
-printf("     irq %d\n", irq_loc_index);
-#endif
-
-    irq[irq_index] = (mapping_irq_t*)malloc(sizeof(mapping_irq_t));
+    printf("     irq %d\n", irq_loc_index);
+#endif
+
+    irq[irq_index] = (mapping_irq_t *) malloc(sizeof(mapping_irq_t));
 
     ///////// get type attribute
-    str = getStringValue(reader,"type", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        type    = %s\n", str);
-#endif
-        if      ( strcmp(str, "HARD") == 0 ) irq[irq_index]->type = 0;
-        else if ( strcmp(str, "SOFT") == 0 ) irq[irq_index]->type = 1;
-        else
-        {
+    str = getStringValue(reader, "type", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        type    = %s\n", str);
+#endif
+        if (strcmp(str, "HARD") == 0 ) {
+            irq[irq_index]->type = 0;
+        }
+        else if (strcmp(str, "SOFT") == 0 ) {
+            irq[irq_index]->type = 1;
+        }
+        else {
             printf("[XML ERROR] undefined IRQ  <type> for processor %d in cluster %d\n",
-                   cluster_index, proc_loc_index );
+                    cluster_index, proc_loc_index);
             exit(1);
         }
     }  
-    else
-    {
+    else {
         printf("[XML ERROR] missing IRQ <type> for processor %d in cluster %d\n",
-               cluster_index, proc_loc_index );
+                cluster_index, proc_loc_index);
         exit(1);
     }
@@ -1325,50 +1256,44 @@
     ///////// get icuid attribute
     value = getIntValue(reader, "icuid", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        icuid   = %d\n", value);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        icuid   = %d\n", value);
 #endif
         irq[irq_index]->icuid = value;
-        if ( value >= 32 )
-        {
+        if (value >= 32) {
             printf("[XML ERROR] IRQ <icuid> too large for processor %d in cluster %d\n",
-                   cluster_index, proc_loc_index );
-            exit(1);
-        }
-    }
-    else
-    {
+                    cluster_index, proc_loc_index);
+            exit(1);
+        }
+    }
+    else {
         printf("[XML ERROR] missing IRQ <icuid> for processor %d in cluster %d\n",
-               cluster_index, proc_loc_index );
+                cluster_index, proc_loc_index);
         exit(1);
     }
 
     ///////// get isr attribute
-    str = getStringValue(reader,"isr", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        isr     = %s\n", str);
-#endif
-        if      ( strcmp(str, "ISR_SWITCH" ) == 0 ) irq[irq_index]->isr = ISR_SWITCH;
-        else if ( strcmp(str, "ISR_IOC"    ) == 0 ) irq[irq_index]->isr = ISR_IOC;
-        else if ( strcmp(str, "ISR_DMA"    ) == 0 ) irq[irq_index]->isr = ISR_DMA;
-        else if ( strcmp(str, "ISR_TTY"    ) == 0 ) irq[irq_index]->isr = ISR_TTY;
-        else if ( strcmp(str, "ISR_TIMER"  ) == 0 ) irq[irq_index]->isr = ISR_TIMER;
-        else
-        {
+    str = getStringValue(reader, "isr", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        isr     = %s\n", str);
+#endif
+        if      (strcmp(str, "ISR_SWITCH" ) == 0) { irq[irq_index]->isr = ISR_SWITCH; }
+        else if (strcmp(str, "ISR_IOC"    ) == 0) { irq[irq_index]->isr = ISR_IOC; }
+        else if (strcmp(str, "ISR_DMA"    ) == 0) { irq[irq_index]->isr = ISR_DMA; }
+        else if (strcmp(str, "ISR_TTY"    ) == 0) { irq[irq_index]->isr = ISR_TTY; }
+        else if (strcmp(str, "ISR_TIMER"  ) == 0) { irq[irq_index]->isr = ISR_TIMER; }
+        else {
             printf("[XML ERROR] illegal IRQ <isr> for processor %d in cluster %d\n",
-                   cluster_index, proc_loc_index );
-            exit(1);
-        }
-#if XML_PARSER_DEBUG
-printf("        isrnum  = %d\n", irq[irq_index]->isr);
+                    cluster_index, proc_loc_index);
+            exit(1);
+        }
+#if XML_PARSER_DEBUG
+        printf("        isrnum  = %d\n", irq[irq_index]->isr);
 #endif
     }  
-    else
-    {
+    else {
         printf("[XML ERROR] missing IRQ <isr> for processor %d in cluster %d\n",
-               cluster_index, proc_loc_index );
+                cluster_index, proc_loc_index);
         exit(1);
     }
@@ -1376,13 +1301,11 @@
     ///////// get channel attribute (optionnal : 0 if missing)
     value = getIntValue(reader, "channel", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        channel = %d\n", value);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        channel = %d\n", value);
 #endif
         irq[irq_index]->channel = value;
     }
-    else
-    {
+    else {
         irq[irq_index]->channel = 0;
     }
@@ -1393,34 +1316,33 @@
 } // end irqNode
 
+
 /////////////////////////////////////////
-void procNode ( xmlTextReaderPtr reader )
-/////////////////////////////////////////
-{
-    unsigned int 	ok;
-    unsigned int    value;
+void procNode(xmlTextReaderPtr reader) {
+    unsigned int ok;
+    unsigned int value;
 
     irq_loc_index = 0;
 
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-    if ( proc_index >= MAX_PROCS )
-    {
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+    if (proc_index >= MAX_PROCS) {
         printf("[XML ERROR] The number of procs is larger than %d\n", MAX_PROCS);
     }
 
 #if XML_PARSER_DEBUG
-printf("\n  proc %d\n", proc_index);
-#endif
-
-    proc[proc_index] = (mapping_proc_t*)malloc(sizeof(mapping_proc_t));
+    printf("\n  proc %d\n", proc_index);
+#endif
+
+    proc[proc_index] = (mapping_proc_t *) malloc(sizeof(mapping_proc_t));
 
 
     /////////// get index attribute (optional)
-    value = getIntValue(reader,"index",&ok);
-    if ( ok && (value != proc_loc_index) )
-    {
-            printf("[XML ERROR] wrong proc index / expected value is %d", 
+    value = getIntValue(reader, "index", &ok);
+    if (ok && (value != proc_loc_index)) {
+        printf("[XML ERROR] wrong proc index / expected value is %d", 
                 proc_loc_index);
-            exit(1);
+        exit(1);
     }
 
@@ -1429,17 +1351,17 @@
 
 #if XML_PARSER_DEBUG
-printf("    irq_offset = %d\n", irq_index);
+    printf("    irq_offset = %d\n", irq_index);
 #endif
 
     int status = xmlTextReaderRead(reader);
-    while ( status == 1 ) 
-    {
-        const char* tag = (const char*)xmlTextReaderConstName(reader);
-
-        if      ( strcmp(tag, "irq")      == 0 ) irqNode(reader);
-        else if ( strcmp(tag, "#text")    == 0 ) { }
-        else if ( strcmp(tag, "#comment") == 0 ) { }
-        else if ( strcmp(tag, "proc")     == 0 ) 
-        {
+    while (status == 1) {
+        const char * tag = (const char *) xmlTextReaderConstName(reader);
+
+        if (strcmp(tag, "irq") == 0) {
+            irqNode(reader);
+        }
+        else if (strcmp(tag, "#text")    == 0) { }
+        else if (strcmp(tag, "#comment") == 0) { }
+        else if (strcmp(tag, "proc")     == 0) {
             proc[proc_index]->irqs = irq_loc_index;
             cluster[cluster_index]->procs++;
@@ -1448,10 +1370,9 @@
             return;
         }
-        else 
-        {
-            printf("[XML ERROR] Unknown tag %s",tag);
-            exit(1);
-        }
-        status = xmlTextReaderRead ( reader );
+        else {
+            printf("[XML ERROR] Unknown tag %s", tag);
+            exit(1);
+        }
+        status = xmlTextReaderRead(reader);
     }
 } // end procNode()
@@ -1459,15 +1380,14 @@
 
 //////////////////////////////////////////
-void  psegNode ( xmlTextReaderPtr reader )
-//////////////////////////////////////////
-{
-    unsigned int 	ok;
-    unsigned int 	value;
-    char*    		str;
-
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-    if ( pseg_index >= MAX_PSEGS )
-    {
+void psegNode(xmlTextReaderPtr reader) {
+    unsigned int ok;
+    unsigned int value;
+    char * str;
+
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+    if (pseg_index >= MAX_PSEGS) {
         printf("[XML ERROR] The number of psegs is larger than %d\n", MAX_PSEGS);
         exit(1);
@@ -1475,22 +1395,20 @@
 
 #if XML_PARSER_DEBUG
-printf("    pseg %d\n", pseg_index);
-#endif
-
-    pseg[pseg_index] = (mapping_pseg_t*)malloc(sizeof(mapping_pseg_t));
+    printf("    pseg %d\n", pseg_index);
+#endif
+
+    pseg[pseg_index] = (mapping_pseg_t *) malloc(sizeof(mapping_pseg_t));
 
     /////// get name attribute
-    str = getStringValue( reader, "name", &ok );
-#if XML_PARSER_DEBUG
-printf("      name = %s\n", str);
-#endif
-    if ( ok ) 
-    {
+    str = getStringValue(reader, "name", &ok);
+#if XML_PARSER_DEBUG
+    printf("      name = %s\n", str);
+#endif
+    if (ok) {
         strncpy(pseg[pseg_index]->name, str, 31);
     }
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <name> for pseg %d in cluster %d\n",
-               pseg_index, cluster_index);
+                pseg_index, cluster_index);
         exit(1);
     }
@@ -1499,45 +1417,40 @@
     str = getStringValue(reader, "type", &ok);
 #if XML_PARSER_DEBUG
-printf("      type = %s\n", str);
-#endif
-    if      (ok && (strcmp(str, "RAM" ) == 0)) pseg[pseg_index]->type = PSEG_TYPE_RAM;
-    else if (ok && (strcmp(str, "ROM" ) == 0)) pseg[pseg_index]->type = PSEG_TYPE_ROM;
-    else if (ok && (strcmp(str, "PERI") == 0)) pseg[pseg_index]->type = PSEG_TYPE_PERI;
-    else
-    {
+    printf("      type = %s\n", str);
+#endif
+    if      (ok && (strcmp(str, "RAM" ) == 0)) { pseg[pseg_index]->type = PSEG_TYPE_RAM; }
+    else if (ok && (strcmp(str, "ROM" ) == 0)) { pseg[pseg_index]->type = PSEG_TYPE_ROM; }
+    else if (ok && (strcmp(str, "PERI") == 0)) { pseg[pseg_index]->type = PSEG_TYPE_PERI; }
+    else {
         printf("[XML ERROR] illegal or missing <type> for pseg %s in cluster %d\n",
-        pseg[pseg_index]->name, cluster_index);
+                pseg[pseg_index]->name, cluster_index);
         exit(1);
     }
 
     //////// get base attribute
-    value = getIntValue( reader, "base", &ok );
-#if XML_PARSER_DEBUG
-printf("      base = 0x%x\n", value);
-#endif
-    if ( ok ) 
-    {
+    value = getIntValue(reader, "base", &ok);
+#if XML_PARSER_DEBUG
+    printf("      base = 0x%x\n", value);
+#endif
+    if (ok) {
         pseg[pseg_index]->base = value;
     }
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <base> for pseg %s in cluster %d\n",
-        pseg[pseg_index]->name, cluster_index);
+                pseg[pseg_index]->name, cluster_index);
         exit(1);
     }
 
     //////// get length attribute
-    value = getIntValue( reader, "length", &ok );
-#if XML_PARSER_DEBUG
-printf("      length = 0x%x\n", value);
-#endif
-    if ( ok )
-    {
+    value = getIntValue(reader, "length", &ok);
+#if XML_PARSER_DEBUG
+    printf("      length = 0x%x\n", value);
+#endif
+    if (ok) {
         pseg[pseg_index]->length = value;
     }  
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <length> for pseg %s in cluster %d\n",
-        pseg[pseg_index]->name, cluster_index);
+                pseg[pseg_index]->name, cluster_index);
         exit(1);
     }
@@ -1550,13 +1463,12 @@
 } // end psegNode()
 
+
 /////////////////////////////////////////////
-void  clusterNode ( xmlTextReaderPtr reader )
-/////////////////////////////////////////////
-{
+void clusterNode(xmlTextReaderPtr reader) {
     unsigned int ok;
     unsigned int value;
 
-    cluster[cluster_index] = (mapping_cluster_t*)malloc(sizeof(mapping_cluster_t));
-    
+    cluster[cluster_index] = (mapping_cluster_t *) malloc(sizeof(mapping_cluster_t));
+
     //initialise all variables
     //they will be incremented by *Node() functions
@@ -1580,9 +1492,10 @@
     found_dma = 0;
 
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
 
     // checking source file consistency
-    if ( cluster_index >= header->clusters )
-    {
+    if (cluster_index >= header->clusters) {
         printf("[XML ERROR] The cluster index is too large : %d\n", cluster_index);
         exit(1);
@@ -1590,28 +1503,27 @@
 
 #if XML_PARSER_DEBUG
-printf("  cluster %d\n", cluster_index);
+    printf("  cluster %d\n", cluster_index);
 #endif
 
 
     /////////// check cluster index attribute (optional)
-    value = getIntValue(reader,"index",&ok);
-    if ( ok && (value != cluster_index) )
-    {
-            printf("[XML ERROR] wrong cluster index / expected value is %d", 
+    value = getIntValue(reader, "index", &ok);
+    if (ok && (value != cluster_index)) {
+        printf("[XML ERROR] wrong cluster index / expected value is %d", 
                 cluster_index);
-            exit(1);
+        exit(1);
     }
 
     ////////// set offsets
-    cluster[cluster_index]->pseg_offset   = pseg_index;
-    cluster[cluster_index]->proc_offset   = proc_index;
+    cluster[cluster_index]->pseg_offset = pseg_index;
+    cluster[cluster_index]->proc_offset = proc_index;
     cluster[cluster_index]->coproc_offset = coproc_index;
     cluster[cluster_index]->periph_offset = periph_index;
 
 #if XML_PARSER_DEBUG
-printf("    pseg_offset   = %d\n", pseg_index);
-printf("    proc_offset   = %d\n", proc_index);
-printf("    coproc_offset = %d\n", coproc_index);
-printf("    periph_offset = %d\n", coproc_index);
+    printf("    pseg_offset   = %d\n", pseg_index);
+    printf("    proc_offset   = %d\n", proc_index);
+    printf("    coproc_offset = %d\n", coproc_index);
+    printf("    periph_offset = %d\n", coproc_index);
 #endif
 
@@ -1619,55 +1531,51 @@
     int status = xmlTextReaderRead(reader);
 
-    while ( status == 1 )
-    {
-        const char* tag = (const char*)xmlTextReaderConstName(reader);
-
-        if      ( strcmp(tag, "pseg")     == 0 ) psegNode(reader);
-        else if ( strcmp(tag, "proc")     == 0 ) procNode(reader);
-        else if ( strcmp(tag, "coproc")   == 0 ) coprocNode(reader);
-        else if ( strcmp(tag, "periph")   == 0 ) periphNode(reader);
-        else if ( strcmp(tag, "#text")    == 0 ) { }
-        else if ( strcmp(tag, "#comment") == 0 ) { }
-        else if ( strcmp(tag, "cluster")  == 0 ) 
-        {
-
-            if(use_xicu == 0xFFFFFFFF)
+    while (status == 1) {
+        const char * tag = (const char *) xmlTextReaderConstName(reader);
+
+        if      (strcmp(tag, "pseg")     == 0) psegNode(reader);
+        else if (strcmp(tag, "proc")     == 0) procNode(reader);
+        else if (strcmp(tag, "coproc")   == 0) coprocNode(reader);
+        else if (strcmp(tag, "periph")   == 0) periphNode(reader);
+        else if (strcmp(tag, "#text")    == 0) { }
+        else if (strcmp(tag, "#comment") == 0) { }
+        else if (strcmp(tag, "cluster")  == 0) {
+
+            if (use_xicu == 0xFFFFFFFF) {
                 use_xicu = found_xicu;
+            }
 
             ////////////////// peripherals checks ////////////////////
-            if( (found_timer  && use_xicu) || (!found_timer  && !use_xicu) )
-            {
+            if ((found_timer  && use_xicu) || (!found_timer  && !use_xicu)) {
                 printf("[XML ERROR] illegal or missing timer peripheral in cluster %d\n", cluster_index);
                 exit(1);
             }
 
-            if( (found_icu  && use_xicu) || (!found_icu  && !use_xicu) )
-            {
+            if ((found_icu && use_xicu) || (!found_icu && !use_xicu)) {
                 printf("[XML ERROR] illegal or missing icu peripheral in cluster %d\n", cluster_index);
                 exit(1);
             }
 
-            if( !found_xicu && use_xicu)
-            {
+            if (!found_xicu && use_xicu) {
                 printf("[XML ERROR] illegal or missing dma peripheral in cluster %d\n", cluster_index);
                 exit(1);
             }
 
-            if(!found_dma)
-            {
+            if (!found_dma) {
                 printf("[XML ERROR] illegal or missing dma peripheral in cluster %d\n", cluster_index);
                 exit(1);
             }
 
-               
-            if(nb_proc_max < cluster[cluster_index]->procs)
+
+            if (nb_proc_max < cluster[cluster_index]->procs) {
                 nb_proc_max = cluster[cluster_index]->procs;
-
-#if XML_PARSER_DEBUG
-printf("    psegs   = %d\n", cluster[cluster_index]->psegs);
-printf("    procs   = %d\n", cluster[cluster_index]->procs);
-printf("    coprocs = %d\n", cluster[cluster_index]->coprocs);
-printf("    periphs = %d\n", cluster[cluster_index]->periphs);
-printf("    end cluster %d\n", cluster_index);
+            }
+
+#if XML_PARSER_DEBUG
+            printf("    psegs   = %d\n", cluster[cluster_index]->psegs);
+            printf("    procs   = %d\n", cluster[cluster_index]->procs);
+            printf("    coprocs = %d\n", cluster[cluster_index]->coprocs);
+            printf("    periphs = %d\n", cluster[cluster_index]->periphs);
+            printf("    end cluster %d\n", cluster_index);
 #endif
             cluster_index++;
@@ -1678,33 +1586,32 @@
 } // end clusterNode()
 
+
 //////////////////////////////////////////////
-void clusterSetNode( xmlTextReaderPtr reader )
-//////////////////////////////////////////////
-{
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-#if XML_PARSER_DEBUG
-printf("\n  clusters set\n");
+void clusterSetNode(xmlTextReaderPtr reader) {
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+#if XML_PARSER_DEBUG
+    printf("\n  clusters set\n");
 #endif
 
     int status = xmlTextReaderRead(reader);
-    while ( status == 1 ) 
-    {
-        const char* tag = (const char*)xmlTextReaderConstName(reader);
-
-        if      ( strcmp(tag, "cluster")    == 0 ) clusterNode(reader);
-        else if ( strcmp(tag, "#text")      == 0 ) { }
-        else if ( strcmp(tag, "#comment")   == 0 ) { }
-        else if ( strcmp(tag, "clusterset") == 0 ) 
-        {
+    while (status == 1) {
+        const char * tag = (const char *) xmlTextReaderConstName(reader);
+
+        if (strcmp(tag, "cluster")    == 0) {
+            clusterNode(reader);
+        }
+        else if (strcmp(tag, "#text")      == 0) { }
+        else if (strcmp(tag, "#comment")   == 0) { }
+        else if (strcmp(tag, "clusterset") == 0) {
             // checking source file consistency
-            if ( cluster_index != header->clusters )
-            {
+            if (cluster_index != header->clusters) {
                 printf("[XML ERROR] Wrong number of clusters\n");
                 exit(1);
             }
 
-            if(header->tty_clusterid == 0xFFFFFFFF)
-            {
+            if (header->tty_clusterid == 0xFFFFFFFF) {
                 printf("[XML ERROR] illegal or missing tty peripheral");
                 exit(1);
@@ -1712,15 +1619,14 @@
 
 #if XML_PARSER_DEBUG
-printf("  end cluster set\n\n");
-#endif
-            header->psegs    = pseg_index;
-            header->procs    = proc_index;
-            header->irqs     = irq_index;
-            header->coprocs  = coproc_index;
+            printf("  end cluster set\n\n");
+#endif
+            header->psegs = pseg_index;
+            header->procs = proc_index;
+            header->irqs = irq_index;
+            header->coprocs = coproc_index;
             header->cp_ports = cp_port_index;
             return;
         }
-        else 
-        {
+        else {
             printf("[XML ERROR] Unknown tag in clusterset node : %s",tag);
             exit(1);
@@ -1730,26 +1636,27 @@
 } // end clusterSetNode()
 
+
 /////////////////////////////////////////////
-void globalSetNode( xmlTextReaderPtr reader )
-/////////////////////////////////////////////
-{
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-#if XML_PARSER_DEBUG
-printf("  globals set\n");
+void globalSetNode(xmlTextReaderPtr reader) {
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+#if XML_PARSER_DEBUG
+    printf("  globals set\n");
 #endif
 
     int status = xmlTextReaderRead(reader);
-    while ( status == 1 ) 
-    {
-        const char* tag = (const char*)xmlTextReaderConstName(reader);
-
-        if      ( strcmp(tag, "vseg")      == 0 ) vsegNode(reader);
-        else if ( strcmp(tag, "#text"  )   == 0 ) { }
-        else if ( strcmp(tag, "#comment")  == 0 ) { }
-        else if ( strcmp(tag, "globalset") == 0 ) 
-        {
-#if XML_PARSER_DEBUG
-printf("  end global set\n\n");
+    while (status == 1) {
+        const char * tag = (const char *) xmlTextReaderConstName(reader);
+
+        if (strcmp(tag, "vseg") == 0) {
+            vsegNode(reader);
+        }
+        else if (strcmp(tag, "#text")     == 0) { }
+        else if (strcmp(tag, "#comment")  == 0) { }
+        else if (strcmp(tag, "globalset") == 0) {
+#if XML_PARSER_DEBUG
+            printf("  end global set\n\n");
 #endif
             header->globals = vseg_index;
@@ -1757,41 +1664,39 @@
             return;
         }
-        else 
-        {
+        else {
             printf("[XML ERROR] Unknown tag in globalset node : %s",tag);
             exit(1);
         }
-        status = xmlTextReaderRead ( reader );
+        status = xmlTextReaderRead(reader);
     }
 } // end globalSetNode()
 
+
 /////////////////////////////////////////////
-void vspaceSetNode( xmlTextReaderPtr reader )
-/////////////////////////////////////////////
-{
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-#if XML_PARSER_DEBUG
-printf("\n  vspaces set\n");
+void vspaceSetNode(xmlTextReaderPtr reader) {
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+#if XML_PARSER_DEBUG
+    printf("\n  vspaces set\n");
 #endif
 
     int status = xmlTextReaderRead ( reader );
-    while ( status == 1 ) 
-    {
-        const char* tag = (const char*)xmlTextReaderConstName(reader);
-
-        if      ( strcmp(tag, "vspace"   ) == 0 ) vspaceNode(reader);
-        else if ( strcmp(tag, "#text"    ) == 0 ) { }
-        else if ( strcmp(tag, "#comment" ) == 0 ) { }
-        else if ( strcmp(tag, "vspaceset") == 0 ) 
-        {
+    while (status == 1) {
+        const char * tag = (const char *) xmlTextReaderConstName(reader);
+
+        if (strcmp(tag, "vspace") == 0) {
+            vspaceNode(reader);
+        }
+        else if (strcmp(tag, "#text"    ) == 0 ) { }
+        else if (strcmp(tag, "#comment" ) == 0 ) { }
+        else if (strcmp(tag, "vspaceset") == 0 ) {
             // checking source file consistency
-            if ( vspace_index != header->vspaces )
-            {
+            if (vspace_index != header->vspaces) {
                 printf("[XML ERROR] Wrong number of vspaces\n");
                 exit(1);
             }
-            else
-            {
+            else {
                 header->vsegs = vseg_index;
                 header->vobjs = vobj_index;
@@ -1800,40 +1705,38 @@
             }
         }
-        else 
-        {
+        else {
             printf("[XML ERROR] Unknown tag in vspaceset node : %s",tag);
             exit(1);
         }
-        status = xmlTextReaderRead ( reader );
+        status = xmlTextReaderRead(reader);
     }
 } // end globalSetNode()
 
+
 //////////////////////////////////////////
-void headerNode(xmlTextReaderPtr reader )
-//////////////////////////////////////////
-{
-    char*       	name;
-    unsigned int 	value;
-    unsigned int 	ok;
-
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-#if XML_PARSER_DEBUG
-printf("mapping_info\n");
-#endif
-
-    header = (mapping_header_t*)malloc(sizeof(mapping_header_t));
+void headerNode(xmlTextReaderPtr reader) {
+    char * name;
+    unsigned int value;
+    unsigned int ok;
+
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+#if XML_PARSER_DEBUG
+    printf("mapping_info\n");
+#endif
+
+    header = (mapping_header_t *) malloc(sizeof(mapping_header_t));
 
     ////////// get name attribute
     name = getStringValue(reader, "name", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("  name = %s\n", name);
-#endif
-	strncpy( header->name, name, 31);
-    }      
-    else
-    {
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("  name = %s\n", name);
+#endif
+        strncpy( header->name, name, 31);
+    }
+    else {
         printf("[XML ERROR] illegal or missing <name> attribute in header\n");
         exit(1);
@@ -1842,13 +1745,11 @@
     /////////// get cluster_x attribute
     cluster_x = getIntValue(reader, "cluster_x", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("  cluster_x = %d\n", cluster_x);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("  cluster_x = %d\n", cluster_x);
 #endif
         header->cluster_x = cluster_x;
     }
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <cluster_x> attribute in header\n");
         exit(1);
@@ -1857,13 +1758,11 @@
     /////////// get cluster_y attribute
     cluster_y = getIntValue(reader, "cluster_y", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("  cluster_y = %d\n", cluster_y);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("  cluster_y = %d\n", cluster_y);
 #endif
         header->cluster_y = cluster_y;
     }
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <cluster_y> attribute in header\n");
         exit(1);
@@ -1871,33 +1770,29 @@
 
     //check the number of cluster
-    value = cluster_x*cluster_y;
-    if ( value >= MAX_CLUSTERS )
-    {
+    value = cluster_x * cluster_y;
+    if (value >= MAX_CLUSTERS) {
         printf("[XML ERROR] The number of clusters is larger than %d\n", MAX_CLUSTERS);
         exit(1);
     }
-	
+
     header->clusters  = value;
 
 #if XML_PARSER_DEBUG
-printf("  clusters = %d\n", value);
+    printf("  clusters = %d\n", value);
 #endif
 
     ///////// get vspaces attribute
     value = getIntValue(reader, "vspaces", &ok);
-    if ( ok )
-    {
-        if ( value >= MAX_VSPACES )
-        {
+    if (ok) {
+        if (value >= MAX_VSPACES) {
             printf("[XML ERROR] The number of vspaces is larger than %d\n", MAX_VSPACES);
             exit(1);
         }
 #if XML_PARSER_DEBUG
-printf("  vspaces = %d\n", value);
-#endif
-	header->vspaces  = value;
-    }
-    else
-    {
+        printf("  vspaces = %d\n", value);
+#endif
+        header->vspaces  = value;
+    }
+    else {
         printf("[XML ERROR] illegal or missing <vspaces> attribute in mapping\n");
         exit(1);
@@ -1914,22 +1809,21 @@
 
     int status = xmlTextReaderRead(reader);
-    while ( status == 1 ) 
-    {
-        const char* tag = (const char*)xmlTextReaderConstName(reader);
-
-        if      ( strcmp(tag, "clusterset")   == 0 ) clusterSetNode(reader);
-        else if ( strcmp(tag, "globalset")    == 0 ) globalSetNode(reader);
-        else if ( strcmp(tag, "vspaceset")    == 0 ) vspaceSetNode(reader);
-        else if ( strcmp(tag, "#text")        == 0 ) { }
-        else if ( strcmp(tag, "#comment")     == 0 ) { }
-        else if ( strcmp(tag, "mapping_info") == 0 ) 
-        {
-#if XML_PARSER_DEBUG
-printf("end mapping_info\n");
+    while (status == 1) {
+        const char * tag = (const char *) xmlTextReaderConstName(reader);
+
+        if (strcmp(tag, "clusterset") == 0) {
+            clusterSetNode(reader);
+        }
+        else if (strcmp(tag, "globalset")    == 0) { globalSetNode(reader); }
+        else if (strcmp(tag, "vspaceset")    == 0) { vspaceSetNode(reader); }
+        else if (strcmp(tag, "#text")        == 0) { }
+        else if (strcmp(tag, "#comment")     == 0) { }
+        else if (strcmp(tag, "mapping_info") == 0) {
+#if XML_PARSER_DEBUG
+            printf("end mapping_info\n");
 #endif
             return;
         }
-        else 
-        {
+        else {
             printf("[XML ERROR] Unknown tag in header node : %s\n",tag);
             exit(1);
@@ -1938,19 +1832,13 @@
     }
 } // end headerNode()
-    
+
+
 ///////////////////////////////////////
-void BuildTable( int fdout,
-               const char* type,
-               unsigned int nb_elem,
-               unsigned int elem_size,
-               char** table)        
-////////////////////////////////////////
-{
+void BuildTable(int fdout, const char * type, unsigned int nb_elem,
+                unsigned int elem_size, char ** table) {
     unsigned int i;
     // write element
-    for ( i = 0 ; i < nb_elem ; i++ )
-    {
-        if(elem_size != write(fdout, table[i], elem_size))
-        {
+    for (i = 0; i < nb_elem; i++) {
+        if (elem_size != write(fdout, table[i], elem_size)) {
             printf("function %s: %s(%d) write  error \n", __FUNCTION__, type, i);
             exit(1);
@@ -1958,23 +1846,28 @@
 
 #if XML_PARSER_DEBUG
-printf("Building binary: writing %s %d\n", type, i);
+        printf("Building binary: writing %s %d\n", type, i);
 #endif
     }
 }
 
-int open_file(const char* file_path)
-{
+
+int open_file(const char * file_path) {
 
     //open file
-    int fdout = open( file_path, (O_CREAT | O_RDWR | O_TRUNC), (S_IWUSR | S_IRUSR) );
-    if ( fdout < 0)
-    {
+    int fdout = open( file_path, (O_CREAT | O_RDWR), (S_IWUSR | S_IRUSR) );
+    if (fdout < 0) {
         perror("open");
         exit(1);
     }
 
-//#if XML_PARSER_DEBUG
-    printf("%s\n",file_path);
-//#endif
+    //reinitialise the file
+    if (ftruncate(fdout, 0)) {
+        perror("truncate");
+        exit(1);
+    }
+
+    //#if XML_PARSER_DEBUG
+    printf("%s\n", file_path);
+    //#endif
 
     return fdout;
@@ -1983,15 +1876,12 @@
 
 ///////////////////////////
-void  buildBin( const char* file_path )
-///////////////////////////
-{
-    unsigned int    length;
+void buildBin(const char * file_path) {
+    unsigned int length;
 
     int fdout = open_file(file_path);
 
     // write header to binary file
-    length = write(fdout, (char*)header, sizeof(mapping_header_t));
-    if ( length != sizeof(mapping_header_t) )
-    {
+    length = write(fdout, (char *) header, sizeof(mapping_header_t));
+    if (length != sizeof(mapping_header_t)) {
         printf("write header error : length = %d \n", length);
         exit(1);
